# Learning

The easy way to use Machine Learning Kit in Flutter.

## Getting Started

Add dependency to your flutter project:

```bash
$ flutter pub add learning
```

**Optimization**

For best performance (and to minimize application size), it's better to add dependency directly from each of sub-package you want to use in your application. 

## Usage

Learning consists of 13 different sub-packages that we can add separately based on our application needs. Please reference to each link below to learn more about the usage of each learning package.
<br><br>
<table width="100%">
  <tr>
    <th>Vision</th>
    <th>Version</th>
    <th>Links</td>
    <th>Example</th>
  </tr>
  <tr>
    <td><code>learning_text_recognition</code></td>
    <td>^0.0.3</td>
    <td>
      <a href="https://pub.dev/packages/learning_text_recognition">Pub.dev</a><br>
      <a href="https://github.com/salkuadrat/learning/tree/master/packages/learning_text_recognition">Github</a>
    </td>
    <td>
      <a href="https://github.com/salkuadrat/learning/tree/master/packages/learning_text_recognition/example">Example</a><br>
      <a href="https://github.com/salkuadrat/learning_apk/raw/master/text_recognition.apk">text_recognition.apk</a>
    </td>
  </tr>
  <tr>
    <td><code>learning_face_detection</code></td>
    <td>^0.0.3</td>
    <td>
      <a href="https://pub.dev/packages/learning_face_detection">Pub.dev</a><br>
      <a href="https://github.com/salkuadrat/learning/tree/master/packages/learning_face_detection">Github</a>
    </td>
    <td>
      <a href="https://github.com/salkuadrat/learning/tree/master/packages/learning_face_detection/example">Example</a><br>
      <a href="https://github.com/salkuadrat/learning_apk/raw/master/face_detection.apk">face_detection.apk</a>
    </td>
  </tr>
  <tr>
    <td><code>learning_pose_detection</code></td>
    <td>^0.0.2</td>
    <td>
      <a href="https://pub.dev/packages/learning_pose_detection">Pub.dev</a><br>
      <a href="https://github.com/salkuadrat/learning/tree/master/packages/learning_pose_detection">Github</a>
    </td>
    <td>
      <a href="https://github.com/salkuadrat/learning/tree/master/packages/learning_pose_detection/example">Example</a><br>
      <a href="https://github.com/salkuadrat/learning_apk/raw/master/pose_detection.apk">pose_detection.apk</a>
    </td>
  </tr>
  <tr>
    <td><code>learning_selfie_segmentation</code></td>
    <td>^0.0.3</td>
    <td>
      <a href="https://pub.dev/packages/learning_selfie_segmentation">Pub.dev</a><br>
      <a href="https://github.com/salkuadrat/learning/tree/master/packages/learning_selfie_segmentation">Github</a>
    </td>
    <td>
      <a href="https://github.com/salkuadrat/learning/tree/master/packages/learning_selfie_segmentation/example">Example</a><br>
      <a href="https://github.com/salkuadrat/learning_apk/raw/master/selfie_segmentation.apk">selfie_segmentation.apk</a>
    </td>
  </tr>
  <tr>
    <td><code>learning_image_labeling</code></td>
    <td>^0.0.2</td>
    <td>
      <a href="https://pub.dev/packages/learning_image_labeling">Pub.dev</a><br>
      <a href="https://github.com/salkuadrat/learning/tree/master/packages/learning_image_labeling">Github</a>
    </td>
    <td>
      <a href="https://github.com/salkuadrat/learning/tree/master/packages/learning_image_labeling/example">Example</a><br>
      <a href="https://github.com/salkuadrat/learning_apk/raw/master/image_labeling.apk">image_labeling.apk</a>
    </td>
  </tr>
  <tr>
    <td><code>learning_barcode_scanning</code></td>
    <td>^0.0.3</td>
    <td>
      <a href="https://pub.dev/packages/learning_barcode_scanning">Pub.dev</a><br>
      <a href="https://github.com/salkuadrat/learning/tree/master/packages/learning_barcode_scanning">Github</a>
    </td>
    <td>
      <a href="https://github.com/salkuadrat/learning/tree/master/packages/learning_barcode_scanning/example">Example</a><br>
      <a href="https://github.com/salkuadrat/learning_apk/raw/master/barcode_scanning.apk">barcode_scanning.apk</a>
    </td>
  </tr>
  <tr>
    <td><code>learning_object_detection</code></td>
    <td>^0.0.2</td>
    <td>
      <a href="https://pub.dev/packages/learning_object_detection">Pub.dev</a><br>
      <a href="https://github.com/salkuadrat/learning/tree/master/packages/learning_object_detection">Github</a>
    </td>
    <td>
      <a href="https://github.com/salkuadrat/learning/tree/master/packages/learning_object_detection/example">Example</a><br>
      <a href="https://github.com/salkuadrat/learning_apk/raw/master/object_detection.apk">object_detection.apk</a>
    </td>
  </tr>
  <tr>
    <td><code>learning_digital_ink_recognition</code></td>
    <td>^0.0.2</td>
    <td>
      <a href="https://pub.dev/packages/learning_digital_ink_recognition">Pub.dev</a><br>
      <a href="https://github.com/salkuadrat/learning/tree/master/packages/learning_digital_ink_recognition">Github</a>
    </td>
    <td>
      <a href="https://github.com/salkuadrat/learning/tree/master/packages/learning_digital_ink_recognition/example">Example</a><br>
      <a href="https://github.com/salkuadrat/learning_apk/raw/master/digital_ink_recognition.apk">digital_ink_recognition.apk</a>
    </td>
  </tr>
</table>
<br>
<table width="100%">
  <tr>
    <th>NLP</th>
    <th>Version</th>
    <th>Links</th>
    <th>Example</th>
  </tr>
  <tr>
    <td><code>learning_language</code></td>
    <td>^0.0.4</td>
    <td>
      <a href="https://pub.dev/packages/learning_language">Pub.dev</a><br>
      <a href="https://github.com/salkuadrat/learning/tree/master/packages/learning_language">Github</a>
    </td>
    <td>
      <a href="https://github.com/salkuadrat/learning/tree/master/packages/learning_language/example">Example</a><br>
      <a href="https://github.com/salkuadrat/learning_apk/raw/master/language.apk">language.apk</a>
    </td>
  </tr>
  <tr>
    <td><code>learning_translate</code></td>
    <td>^0.0.4</td>
    <td>
      <a href="https://pub.dev/packages/learning_translate">Pub.dev</a><br>
      <a href="https://github.com/salkuadrat/learning/tree/master/packages/learning_translate">Github</a>
    </td>
    <td>
      <a href="https://github.com/salkuadrat/learning/tree/master/packages/learning_translate/example">Example</a><br>
      <a href="https://github.com/salkuadrat/learning_apk/raw/master/translate.apk">translate.apk</a>
    </td>
  </tr>
  <tr>
    <td><code>learning_entity_extraction</code></td>
    <td>^0.0.3</td>
    <td>
      <a href="https://pub.dev/packages/learning_entity_extraction">Pub.dev</a><br>
      <a href="https://github.com/salkuadrat/learning/tree/master/packages/learning_entity_extraction">Github</a>
    </td>
    <td>
      <a href="https://github.com/salkuadrat/learning/tree/master/packages/learning_entity_extraction/example">Example</a><br>
      <a href="https://github.com/salkuadrat/learning_apk/raw/master/entity_extraction.apk">entity_extraction.apk</a>
    </td>
  </tr>
  <tr>
    <td><code>learning_smart_reply</code></td>
    <td>^0.0.3</td>
    <td>
      <a href="https://pub.dev/packages/learning_smart_reply">Pub.dev</a><br>
      <a href="https://github.com/salkuadrat/learning/tree/master/packages/learning_smart_reply">Github</a>
    </td>
    <td>
      <a href="https://github.com/salkuadrat/learning/tree/master/packages/learning_smart_reply/example">Example</a>
    </td>
  </tr>
</table>
<br>
<table width="100%">
  <tr>
    <th>Helper</th>
    <th>Version</th>
    <th>Links</td>
  </tr>
  <tr>
    <td><code>learning_input_image</code></td>
    <td>^0.0.6+2</td>
    <td>
      <a href="https://pub.dev/packages/learning_input_image">Pub.dev</a><br>
      <a href="https://github.com/salkuadrat/learning/tree/master/packages/learning_input_image">Github</a>
    </td>
  </tr>
</table>

## Example Project

You can learn more from example project [here](example).
